;##################################################################
;
;   Phoenix III for the TI-86 - addresses and structure defintions
;
;   Programmed by Patrick Davidson (pad@calc.org)
;        
;   This program is in the public domain.  There is no warranty.
;
;   This file was last updated January 17, 2002.
;
;##################################################################

;############## Definitions of system calls

_ldHLind            =$4010         
_divHLby10          =$4044
_MOV10TOOP1         =$42d7
_SET_ABS_SRC_ADDR   =$4647
_SET_MM_NUM_BYTES   =$464f
_FINDSYM            =$46cb
_putc               =$4a2b             
_puts               =$4a37            
_clrLCD             =$4a7e
_vputs              =$4aa5
_runindicoff        =$4ab1
_flushAllMenus      =$49dc
_SET_ABS_DEST_ADDR  =$5285
_mm_ldir            =$52ed

;############## Definitions of system memory areas

CONTRAST            =$c008              
_curRow             =$c00f          
_curCol             =$c010              
textShadow          =$c0f9
_penCol             =$c37c
_plotSScreen        =$c9fa             

_asm_exec_ram       =$d748
                                                
;############## Program's main addresses addresses

main_code           =$807d
int_handler         =$8080

universe_data       =$a000

variables           =$d750

test_coords         =$dffc
TEMP_AREA           =$e000

background_plane0   =$e800
background_plane1   =$ec00
buffer1_plane0      =$f000
buffer1_plane1      =$f400
buffer2_plane0      =$f800
buffer2_plane1      =$fc00

;############## Key codes

K_ENTER             =$09
K_PLUS              =$0a
K_MINUS             =$0b
K_CLEAR             =$0f
K_DEL               =$20
K_SECOND            =$36
K_EXIT              =$37
K_MORE              =$38

;############## Misc build constants

#define __TI86__
#define NAMELEN 16
